require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ASM_RISCV_ELF_H)) {
    eval 'sub _ASM_RISCV_ELF_H () {1;}' unless defined(&_ASM_RISCV_ELF_H);
    require 'asm/ptrace.ph';
    eval 'sub ELF_NGREG () {($sizeof{ &elf_gregset_t} / $sizeof{ &elf_greg_t});}' unless defined(&ELF_NGREG);
    eval 'sub ELF_NFPREG () {($sizeof{\'struct __riscv_d_ext_state\'} / $sizeof{ &elf_fpreg_t});}' unless defined(&ELF_NFPREG);
    if((defined(&__riscv_xlen) ? &__riscv_xlen : undef) == 64) {
	eval 'sub ELF_RISCV_R_SYM {
	    my($r_info) = @_;
    	    eval q( &ELF64_R_SYM($r_info));
	}' unless defined(&ELF_RISCV_R_SYM);
	eval 'sub ELF_RISCV_R_TYPE {
	    my($r_info) = @_;
    	    eval q( &ELF64_R_TYPE($r_info));
	}' unless defined(&ELF_RISCV_R_TYPE);
    } else {
	eval 'sub ELF_RISCV_R_SYM {
	    my($r_info) = @_;
    	    eval q( &ELF32_R_SYM($r_info));
	}' unless defined(&ELF_RISCV_R_SYM);
	eval 'sub ELF_RISCV_R_TYPE {
	    my($r_info) = @_;
    	    eval q( &ELF32_R_TYPE($r_info));
	}' unless defined(&ELF_RISCV_R_TYPE);
    }
    eval 'sub R_RISCV_NONE () {0;}' unless defined(&R_RISCV_NONE);
    eval 'sub R_RISCV_32 () {1;}' unless defined(&R_RISCV_32);
    eval 'sub R_RISCV_64 () {2;}' unless defined(&R_RISCV_64);
    eval 'sub R_RISCV_RELATIVE () {3;}' unless defined(&R_RISCV_RELATIVE);
    eval 'sub R_RISCV_COPY () {4;}' unless defined(&R_RISCV_COPY);
    eval 'sub R_RISCV_JUMP_SLOT () {5;}' unless defined(&R_RISCV_JUMP_SLOT);
    eval 'sub R_RISCV_TLS_DTPMOD32 () {6;}' unless defined(&R_RISCV_TLS_DTPMOD32);
    eval 'sub R_RISCV_TLS_DTPMOD64 () {7;}' unless defined(&R_RISCV_TLS_DTPMOD64);
    eval 'sub R_RISCV_TLS_DTPREL32 () {8;}' unless defined(&R_RISCV_TLS_DTPREL32);
    eval 'sub R_RISCV_TLS_DTPREL64 () {9;}' unless defined(&R_RISCV_TLS_DTPREL64);
    eval 'sub R_RISCV_TLS_TPREL32 () {10;}' unless defined(&R_RISCV_TLS_TPREL32);
    eval 'sub R_RISCV_TLS_TPREL64 () {11;}' unless defined(&R_RISCV_TLS_TPREL64);
    eval 'sub R_RISCV_IRELATIVE () {58;}' unless defined(&R_RISCV_IRELATIVE);
    eval 'sub R_RISCV_BRANCH () {16;}' unless defined(&R_RISCV_BRANCH);
    eval 'sub R_RISCV_JAL () {17;}' unless defined(&R_RISCV_JAL);
    eval 'sub R_RISCV_CALL () {18;}' unless defined(&R_RISCV_CALL);
    eval 'sub R_RISCV_CALL_PLT () {19;}' unless defined(&R_RISCV_CALL_PLT);
    eval 'sub R_RISCV_GOT_HI20 () {20;}' unless defined(&R_RISCV_GOT_HI20);
    eval 'sub R_RISCV_TLS_GOT_HI20 () {21;}' unless defined(&R_RISCV_TLS_GOT_HI20);
    eval 'sub R_RISCV_TLS_GD_HI20 () {22;}' unless defined(&R_RISCV_TLS_GD_HI20);
    eval 'sub R_RISCV_PCREL_HI20 () {23;}' unless defined(&R_RISCV_PCREL_HI20);
    eval 'sub R_RISCV_PCREL_LO12_I () {24;}' unless defined(&R_RISCV_PCREL_LO12_I);
    eval 'sub R_RISCV_PCREL_LO12_S () {25;}' unless defined(&R_RISCV_PCREL_LO12_S);
    eval 'sub R_RISCV_HI20 () {26;}' unless defined(&R_RISCV_HI20);
    eval 'sub R_RISCV_LO12_I () {27;}' unless defined(&R_RISCV_LO12_I);
    eval 'sub R_RISCV_LO12_S () {28;}' unless defined(&R_RISCV_LO12_S);
    eval 'sub R_RISCV_TPREL_HI20 () {29;}' unless defined(&R_RISCV_TPREL_HI20);
    eval 'sub R_RISCV_TPREL_LO12_I () {30;}' unless defined(&R_RISCV_TPREL_LO12_I);
    eval 'sub R_RISCV_TPREL_LO12_S () {31;}' unless defined(&R_RISCV_TPREL_LO12_S);
    eval 'sub R_RISCV_TPREL_ADD () {32;}' unless defined(&R_RISCV_TPREL_ADD);
    eval 'sub R_RISCV_ADD8 () {33;}' unless defined(&R_RISCV_ADD8);
    eval 'sub R_RISCV_ADD16 () {34;}' unless defined(&R_RISCV_ADD16);
    eval 'sub R_RISCV_ADD32 () {35;}' unless defined(&R_RISCV_ADD32);
    eval 'sub R_RISCV_ADD64 () {36;}' unless defined(&R_RISCV_ADD64);
    eval 'sub R_RISCV_SUB8 () {37;}' unless defined(&R_RISCV_SUB8);
    eval 'sub R_RISCV_SUB16 () {38;}' unless defined(&R_RISCV_SUB16);
    eval 'sub R_RISCV_SUB32 () {39;}' unless defined(&R_RISCV_SUB32);
    eval 'sub R_RISCV_SUB64 () {40;}' unless defined(&R_RISCV_SUB64);
    eval 'sub R_RISCV_GNU_VTINHERIT () {41;}' unless defined(&R_RISCV_GNU_VTINHERIT);
    eval 'sub R_RISCV_GNU_VTENTRY () {42;}' unless defined(&R_RISCV_GNU_VTENTRY);
    eval 'sub R_RISCV_ALIGN () {43;}' unless defined(&R_RISCV_ALIGN);
    eval 'sub R_RISCV_RVC_BRANCH () {44;}' unless defined(&R_RISCV_RVC_BRANCH);
    eval 'sub R_RISCV_RVC_JUMP () {45;}' unless defined(&R_RISCV_RVC_JUMP);
    eval 'sub R_RISCV_GPREL_I () {47;}' unless defined(&R_RISCV_GPREL_I);
    eval 'sub R_RISCV_GPREL_S () {48;}' unless defined(&R_RISCV_GPREL_S);
    eval 'sub R_RISCV_TPREL_I () {49;}' unless defined(&R_RISCV_TPREL_I);
    eval 'sub R_RISCV_TPREL_S () {50;}' unless defined(&R_RISCV_TPREL_S);
    eval 'sub R_RISCV_RELAX () {51;}' unless defined(&R_RISCV_RELAX);
    eval 'sub R_RISCV_SUB6 () {52;}' unless defined(&R_RISCV_SUB6);
    eval 'sub R_RISCV_SET6 () {53;}' unless defined(&R_RISCV_SET6);
    eval 'sub R_RISCV_SET8 () {54;}' unless defined(&R_RISCV_SET8);
    eval 'sub R_RISCV_SET16 () {55;}' unless defined(&R_RISCV_SET16);
    eval 'sub R_RISCV_SET32 () {56;}' unless defined(&R_RISCV_SET32);
    eval 'sub R_RISCV_32_PCREL () {57;}' unless defined(&R_RISCV_32_PCREL);
    eval 'sub R_RISCV_PLT32 () {59;}' unless defined(&R_RISCV_PLT32);
    eval 'sub R_RISCV_SET_ULEB128 () {60;}' unless defined(&R_RISCV_SET_ULEB128);
    eval 'sub R_RISCV_SUB_ULEB128 () {61;}' unless defined(&R_RISCV_SUB_ULEB128);
}
1;
